// -------------------------------------------------------------------------------
// 
// 		cwCu		WbCugpvOwb_t@C
// 
// 				Ver 3.23b
// 
// -------------------------------------------------------------------------------

#ifndef DX_USECLIB_H
#define DX_USECLIB_H

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"

#ifndef DX_NON_OGGTHEORA
#include "DxMovie.h"
#endif

#if !defined( DX_NON_OPUS ) || !defined( DX_NON_OGGVORBIS ) || !defined( DX_NON_MOVIE )
#include "DxSoundConvert.h"
#endif

#include "DxFile.h"
#include "DxBaseFunc.h"

//namespace DxLib
//{

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

#ifndef DX_NON_MERSENNE_TWISTER

#define MT_N 624

typedef struct tagMERSENNE_TWISTER_DATA
{
	int mti ;                       /* index number */
	unsigned int mt[ MT_N + 1 ] ;   /* the array for the state vector */
	unsigned int mtr[ MT_N ] ;      /* the array for the random number */
} MERSENNE_TWISTER_DATA ;

#endif // DX_NON_MERSENNE_TWISTER

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------










#ifndef DX_NON_MERSENNE_TWISTER

// Copyright SYN--------------------------------------
extern unsigned int		CheckMMX(void) ;
extern void				srandMT(unsigned int seed) ;
extern void				generateMT(void) ;
extern unsigned int		randMT(void) ;
// ---------------------------------------------------

extern void				initMTData( MERSENNE_TWISTER_DATA *MTData, unsigned int seed ) ;
extern unsigned int		randMTData( MERSENNE_TWISTER_DATA *MTData ) ;

#endif // DX_NON_MERSENNE_TWISTER






#ifndef DX_NON_TIFFREAD
extern	int		LoadTiffImage( STREAMDATA *Src, BASEIMAGE *BaseImage, int GetFormatOnly ) ;						// shee摜̓ǂ݂
#endif
#ifndef DX_NON_PNGREAD
extern	int		LoadPngImage(     STREAMDATA *Src, BASEIMAGE *BaseImage, int GetFormatOnly ) ;					// omf摜̓ǂ݂
#ifndef DX_NON_SAVEFUNCTION
extern	int		SaveBaseImageToPngBase( const char *FilePathW, const char *FilePathA, BASEIMAGE *BaseImage, int CompressionLevel ) ;																					// {摜f[^omf摜Ƃĕۑ
#endif
#endif
#ifndef DX_NON_JPEGREAD
extern	int		LoadJpegImageBase( STREAMDATA *Src, BASEIMAGE *BaseImage, int GetFormatOnly, int GetExifOnly, void *ExifBuffer, size_t ExifBufferSize ) ;	// iodf摜̓ǂ݂ (̂ DxUseCLib.cpp ̒)
extern	int		LoadJpegImage( STREAMDATA *Src, BASEIMAGE *BaseImage, int GetFormatOnly ) ;						// iodf摜̓ǂ݂ (̂ DxUseCLib.cpp ̒)
#ifndef DX_NON_SAVEFUNCTION
extern	int		SaveBaseImageToJpegBase( const char *FilePathW, const char *FilePathA, BASEIMAGE *BaseImage, int Quality, int Sample2x1 ) ;																			// {摜f[^iodf摜Ƃĕۑ
#endif
#endif




extern	int			INT64DIV(  const BYTE *Int64,  int   DivNum ) ;
extern	DWORD		UINT64DIV( const BYTE *UInt64, DWORD DivNum ) ;
extern	int			INT64MOD(  const BYTE *Int64,  int   ModNum ) ;
extern	DWORD		UINT64MOD( const BYTE *UInt64, DWORD ModNum ) ;





extern	int			MQOZ_ZIP_uncompress( void *dest, size_t destLen, const void *source, size_t sourceLen ) ;		// MQOZ` ZIP kꂽf[^𓀂





#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3
extern	int SetupSoundConvert_DSMP3(            SOUNDCONV *SoundConv ) ;							// DirectShowgMP3t@CRo[gZbgAbvs( [] -1:G[ )
#endif
#endif
#endif




#ifndef DX_NON_OGGVORBIS
extern	int      SetupSoundConvert_OGG(            SOUNDCONV *SoundConv ) ;								// nfft@C̃ZbgAbvs( [] -1:G[ )
extern	int      TerminateSoundConvert_OGG(        SOUNDCONV *SoundConv ) ;								// nfft@Čns
extern	int      ConvertProcessSoundConvert_OGG(   SOUNDCONV *SoundConv ) ;								// ϊ̃obt@Ƀf[^[
//extern int     SetTimeSoundConvert_OGG(          SOUNDCONV *SoundConv, int Time ) ;					// ϊʒuύX( ~bP )
extern	int      SetSampleTimeSoundConvert_OGG(    SOUNDCONV *SoundConv, LONGLONG SampleTime ) ;		// ϊ̈ʒuύX( TvP )
extern	LONGLONG GetSoundConvertDestSize_Fast_OGG( SOUNDCONV *SoundConv ) ;								// ϊ̑}̃f[^TCY𓾂
extern	int      GetSoundConvertLoopAreaInfo_OGG(  SOUNDCONV *SoundConv, LONGLONG *LoopStartPos, LONGLONG *LoopEndPos ) ;	// [v擾( [] -1:G[ )
#endif






#ifndef DX_NON_OPUS
extern	int      SetupSoundConvert_OPUS(            SOUNDCONV *SoundConv ) ;							// Opust@C̃ZbgAbvs( [] -1:G[ )
extern	int      TerminateSoundConvert_OPUS(        SOUNDCONV *SoundConv ) ;							// Opust@Čns
extern	int      ConvertProcessSoundConvert_OPUS(   SOUNDCONV *SoundConv ) ;							// ϊ̃obt@Ƀf[^[
extern	int      SetSampleTimeSoundConvert_OPUS(    SOUNDCONV *SoundConv, LONGLONG SampleTime ) ;		// ϊ̈ʒuύX( TvP )
extern	LONGLONG GetSoundConvertDestSize_Fast_OPUS( SOUNDCONV *SoundConv ) ;							// ϊ̑}̃f[^TCY𓾂
#endif






#ifndef DX_NON_OGGTHEORA

extern int	TheoraDecode_GrobalInitialize( void ) ;																					// \tgIɈxĂԂׂ֐

// Ogg Theora ǂݍݏ̏s( ߂l  0:s  1ȏ: )
extern DWORD_PTR  TheoraDecode_InitializeStream(
	STREAMDATASHRED *	StreamShred,
	DWORD_PTR			StreamData,
	int					StockFrameNum /* = 10 */,
	int					NotUseYUVFormatSurface /* = FALSE */,
	int					NotUseYUVGrHandle /* = TRUE */,
	int					ASyncTrhead /* = FALSE */
) ;
extern int	TheoraDecode_Terminate( DWORD_PTR Handle ) ;																			// Ogg Theora ǂݍݏ̌ns
extern int	TheoraDecode_SurfaceTerminate( DWORD_PTR Handle ) ;																		// Ogg Theora ŎgpĂT[tFX

extern int	TheoraDecode_GetInfo( DWORD_PTR Handle, THEORADECODE_INFO *Info ) ;														// ̏擾
extern int	TheoraDecode_GetCurrentFrame( DWORD_PTR Handle ) ;																		// Jgt[擾
	
extern int	TheoraDecode_IncToFrame( DWORD_PTR Handle, int AddNum = 1 ) ;															// Jgt[Pt[i߂( ߂l  0:L[t[Ȃ  1:L[t[  -1:G[ )
extern int	TheoraDecode_SeekToFrame( DWORD_PTR Handle, int Frame ) ;																// Jgt[w̃t[Ɉړ
extern int	TheoraDecode_SeekToTime( DWORD_PTR Handle, LONGLONG Time ) ;															// Jgt[w̍ĐԂɈړ( Pʂ̓}CNb )

extern int	TheoraDecode_SetupImage( DWORD_PTR Handle, int BaseImage = 0, int YUVGrHandle = 0, int YUVImage = 0, int ASyncThread = FALSE ) ;				// Jgt[RGB摜쐬( ߂l  1:쐬ꂽ  0:Ȃ )
extern const BASEIMAGE *	TheoraDecode_GetBaseImage( DWORD_PTR Handle ) ;															// ꎞobt@̃AhX擾
extern const void *			TheoraDecode_GetYUVImage( DWORD_PTR Handle ) ;															// ꎞobt@ YUV tH[}bg̃T[tFX𓾂
extern int	TheoraDecode_GetYGrHandle( DWORD_PTR Handle ) ;																			// YUVJ[ ỸOtBbNnh擾
extern int	TheoraDecode_GetUVGrHandle( DWORD_PTR Handle ) ;																		// YUVJ[ UṼOtBbNnh擾

extern int	TheoraDecode_IsIdle( DWORD_PTR Handle ) ;																				// fR[hXbhAChԂǂ𒲂ׂ( ߂l  1:ACh  0:ғ )

#endif






//}

#endif // DX_USECLIB_H
